<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: do.php
| Version: 1.0, December 27th, 2011
| Author: Ionescu Vlad (Senzo)
| Co-author: Nicolae Crefelean (kneekoo)
| Co-Co-author: Philip Daly (HobbyMan)
| Website: http://www.phpfusion.ro/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
if (!iMEMBER) { exit(); }
require_once INFUSIONS."fusion_voice_panel/includes/func.php";
require_once INFUSIONS."fusion_voice_panel/includes/locale.php";

if (isset($_GET['action']) && isnum($_GET['action']) && isset($_GET['project_id']) && isnum($_GET['project_id'])) {
	switch($_GET['action']) {

		// add/change number of votes
		case 1:
		if (isset($_GET['votes']) && preg_match("#^[0-3]$#", $_GET['votes'])) {
			$errors = "";
			$total_votes = dbresult(dbquery("SELECT SUM(voice_option) FROM ".DB_PREFIX."voice WHERE voice_user='".$userdata['user_id']."'"), 0);
			$total_votes = !empty($total_votes) ? $total_votes : 0;

			$select_votes = dbquery("SELECT voice_option FROM ".DB_PREFIX."voice WHERE voice_user = '".$userdata['user_id']."' AND project_id = '".$_GET['project_id']."' ");
			$data = dbarray($select_votes);
			$data['voice_option'] = !empty($data['voice_option']) ? $data['voice_option'] : 0;

			if ($_GET['votes'] != $data['voice_option']) {
				if ($_GET['votes'] < $data['voice_option']) {
					$update_votes = dbquery("UPDATE ".DB_PREFIX."voice SET `voice_option` = '".$_GET['votes']."', `voice_datestamp` = '".time()."' WHERE `project_id` = '".$_GET['project_id']."' AND voice_user='".$userdata['user_id']."'");
				} else {
					$curent_votes = $_GET['votes'] - $data['voice_option'];
					if (($total_votes + $curent_votes) <= $voice_settings['votes_limit']) {
						if(dbrows($select_votes)) {
							$update_votes = dbquery("UPDATE ".DB_PREFIX."voice SET `voice_option` = '".$_GET['votes']."', `voice_datestamp` = '".time()."' WHERE `project_id` = '".$_GET['project_id']."' AND voice_user='".$userdata['user_id']."'");
						} else {
							$insert_votes = dbquery("INSERT INTO ".DB_PREFIX."voice (`voice_user` ,`project_id` ,`voice_option` ,`voice_datestamp`)
														VALUES ('".$userdata['user_id']."', '".$_GET['project_id']."', '".$_GET['votes']."', '".time()."');");
						}
					} else {
						$errors .= $locale['fuvo_021'];
					}
				}
			}

			$sum = mysql_result(dbquery("SELECT SUM(voice_option) FROM ".DB_PREFIX."voice WHERE project_id = '".$_GET['project_id']."' "), 0);
			$update_status = dbquery("UPDATE ".DB_PREFIX."voice_projects SET project_votes = '".$sum."' WHERE `project_id` = '".$_GET['project_id']."' ");

			if (empty($errors)) {
				echo "<table cellpadding='5' cellspacing='3' width='75px' align='center' class='tbl-border'>";
				for ($i=0; $i<4; $i++) {
					echo "<tr><td class='".($_GET['votes'] == $i ? "tbl2" : "tbl1")."' align='center' style='font-size:14px'><a href='javascript:void(0);' onclick='ajaxCall(\"div".$_GET['project_id']."\", \"action=1&project_id=".$_GET['project_id']."&votes=".$i."&project_status=".$_GET['project_status']."\", \"votes".$_GET['project_id']."\", \"action=3&project_status=".$_GET['project_status']."&project_id=".$_GET['project_id']."\", \"voted\", \"action=4&project_id=1\");'><b>".$i."</b><br />".($i == 1 ? $locale['fuvo_002'] : $locale['fuvo_003'])."</a></td></tr>\n";
				}
				echo "</table>\n";
			} else {
				echo $errors;
			}

		} else {
			die();
		}
		break;

		// change status
		case 2:
			if(checkrights("FVP") || defined("iAUTH") || $_GET['aid'] == iAUTH) {
				if (!isset($_GET['status']) || !preg_match("#^[0-4]$#", $_GET['status'])) { die(); }
				$sum = mysql_result(dbquery("SELECT SUM(voice_option) FROM ".DB_PREFIX."voice WHERE project_id = '".$_GET['project_id']."' "), 0);
				if (preg_match("#^[3|4]$#", $_GET['status'])) {
					$delete_user_votes = dbquery("DELETE FROM ".DB_PREFIX."voice WHERE `project_id` = '".$_GET['project_id']."' ");
					$update_status = dbquery("UPDATE ".DB_PREFIX."voice_projects SET `project_status` = '".$_GET['status']."', project_votes = '0' WHERE `project_id` = '".$_GET['project_id']."' ");
				} else {
					$update_status = dbquery("UPDATE ".DB_PREFIX."voice_projects SET `project_status` = '".$_GET['status']."', project_votes = '".$sum."' WHERE `project_id` = '".$_GET['project_id']."' ");
				}
				echo "<table cellpadding='5' cellspacing='3' width='75px' align='center'><tr>";
				for($k=1; $k<5; $k++) {
					echo "<td class='".($_GET['status'] == $k ? "tbl2" : "tbl1")."'><a href='javascript:void(0);' onclick='ajaxCall(\"status".$_GET['project_id']."\", \"aid=".iAUTH."&action=2&project_id=".$_GET['project_id']."&status=".$k."\");'>".$locale['status'][$k]."</td>";
				}
				echo "</tr></table>";
			} else {
				die();
			}
		break;

		// update total votes
		case 3:
			if(isset($_GET['project_id']) && isnum($_GET['project_id'])) {
				if(!isset($_GET['project_status']) || !isnum($_GET['project_status'])) { exit(); }
				$show_vote = true;
				if ($_GET['project_status'] >= "3") {
					$final_votes = dbquery("SELECT project_votes FROM ".DB_PREFIX."voice_projects WHERE project_id = '".$_GET['project_id']."'");
					$x = dbarray($final_votes);
					$votes = $x['project_votes'];
					$show_vote = false;
				} else {
					$votes = mysql_result(dbquery("SELECT SUM(voice_option) FROM ".DB_PREFIX."voice WHERE project_id = '".$_GET['project_id']."' "), 0);
					$votes = !empty($votes) ? $votes : 0;
				}
				echo "<b>".$votes."</b><br />".($votes == 1 ? $locale['fuvo_002'] : $locale['fuvo_003']);
			}
		break;

		// update last voted personal stats
		case 4:
			$votes_awarded = 0;
			$select_user_votes = dbquery("SELECT tvp.project_id, tvp.project_name, tv.voice_option FROM ".DB_PREFIX."voice_projects tvp LEFT JOIN ".DB_PREFIX."voice tv ON tvp.project_id=tv.project_id WHERE tv.voice_user = '".$userdata['user_id']."' AND tv.voice_option > 0 ORDER BY tvp.project_datestamp DESC LIMIT 5");
			if (dbrows($select_user_votes)) {
				echo $locale['fuvo_018'];
				echo "<table cellpadding='5' cellspacing='3' width='100%' align='center'>";
				echo "<tr>";
				echo "<td class='tbl2' align='center' width='50'><b>".$locale['fuvo_038']."</b></td>";
				echo "<td class='tbl2' align='center'><b>".$locale['fuvo_039']."</b></td>";
				echo "</tr>";
				while ($xdata = dbarray($select_user_votes)) {
					$votes_awarded += $xdata['voice_option'];
					echo "<tr>";
					echo "<td class='tbl1' align='center'>".$xdata['voice_option']."</td>";
					echo "<td class='tbl1'><a href='".FUSION_SELF."?project_id=".$xdata['project_id']."'>".$xdata['project_name']."</a></td>";
					echo "</tr>";
				}
				echo "</table>";
				echo "<script type='text/javascript'>$('#voted').css('vertical-align', 'top');</script>";
			} else {
				echo $locale['fuvo_019'];
				echo "<script type='text/javascript'>$('#voted').css('vertical-align', 'middle');</script>";
			}
			echo "<p style='padding: 10px 0'>" . $locale['fuvo_049'] . remaining_votes($votes_awarded) . "</p>\n";
		break;
	}
} else {
	die();
}
?>
