<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk
+--------------------------------------------------------+
| Filename: fusion_voice.php
| Version: 1.0, December 27th, 2011
| Author: Ionescu Vlad (Senzo)
| Co-author: Nicolae Crefelean (kneekoo)
| Co-Co-author: Philip Daly (HobbyMan)
| Website: http://www.phpfusion.ro/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/header.php";
require_once INCLUDES."bbcode_include.php";
require_once INFUSIONS."fusion_voice_panel/includes/func.php";
require_once INFUSIONS."fusion_voice_panel/includes/locale.php";
add_to_title(" - " . $locale['title']);

if (isset($_GET['project_id']) && isnum($_GET['project_id'])) {
	$p = dbarray(dbquery("SELECT tvp.*, tu.user_name FROM ".DB_PREFIX."voice_projects tvp JOIN ".DB_PREFIX."users tu ON tvp.project_user = tu.user_id WHERE tvp.project_id = '".$_GET['project_id']."'"));
	if ($p) {
		opentable($locale['title'] . " - ".$p['project_name']);
		$description = $p['project_description'];
		$nr_com = dbcount("(comment_id)", DB_COMMENTS, "comment_type='FV' AND comment_item_id='".$p['project_id']."' ");
		$show_vote = iMEMBER ? true : false;
		echo "<table cellpadding='5' cellspacing='3' width='100%' align='center'><tr>";
		if($p['project_status'] == "3") {
			$final_votes = dbquery("SELECT project_votes FROM ".DB_PREFIX."voice_projects WHERE project_id = '".$p['project_id']."'");
			$x = dbarray($final_votes);
			$votes = $x['project_votes'];
			$show_vote = false;
		} else {
			$votes = mysql_result(dbquery("SELECT SUM(voice_option) FROM ".DB_PREFIX."voice WHERE project_id = '".$p['project_id']."' "), 0);
			$votes = !empty($votes) ? $votes : 0;
		}
		echo "<td class='tbl2' width='120' align='center' valign='top'>";
		echo "<table cellpadding='5' cellspacing='3' width='75' align='center' class='tbl-border'><tr>";
		echo "<td class='tbl1' align='center' style='font-size:14px' id='votes".$p['project_id']."'><b>".$votes."</b><br />".($votes == 1 ? $locale['fuvo_002'] : $locale['fuvo_003'])."</td>";
		echo "</tr>\n";
		if ($show_vote) {
			echo "<tr>";
			echo "<td class='tbl1' align='center'><a href='#' id='vote".$p['project_id']."'>".$locale['fuvo_001']."</a></td>\n";
			echo "</tr>\n";
		}
		echo "</table>\n</td>";
		echo "<td class='tbl2' width='120' style='display: none' align='center' valign='top' id='vote-options".$p['project_id']."'>";
		$user_votes = dbquery("SELECT voice_option FROM ".DB_PREFIX."voice WHERE voice_user = '".$userdata['user_id']."' AND project_id = '".$p['project_id']."'");
		$data = dbarray($user_votes);
		echo "<div id='div".$p['project_id']."'>";
		echo "<table cellpadding='5' cellspacing='3' width='75' align='center' class='tbl-border'>";
		for ($i=0; $i<4; $i++) {
			echo "<tr><td class='".($data['voice_option'] == $i ? "tbl2" : "tbl1")."' align='center' style='font-size:14px'><a href='javascript:void(0);' onclick='ajaxCall(\"div".$p['project_id']."\", \"action=1&amp;project_id=".$p['project_id']."&amp;votes=".$i."&amp;project_status=".$p['project_status']."\", \"votes".$p['project_id']."\", \"action=3&amp;project_status=".$p['project_status']."&amp;project_id=".$p['project_id']."\");'><b>".$i."</b><br />".($i == 1 ? $locale['fuvo_002'] : $locale['fuvo_003'])."</a></td></tr>\n";
		}
		echo "</table>\n";
		echo "</div>";
		echo "</td>";
		echo "<td class='tbl1' align='center' valign='top'>
			<div style='text-align: left'>".nl2br(parseubb(parsesmileys($description)))."</div>
			<div style='text-align: left; padding-top: 10px;'>" . $locale['fuvo_004'] . " <a href='".BASEDIR."profile.php?lookup=".$p['project_user']."'>".$p['user_name']."</a> - ". showdate("longdate", $p['project_datestamp']) ."</div>
		</td>";
		if (iADMIN) {
			echo "</tr>\n<tr>";
			echo "<td class='tbl2' colspan='3' align='right'>
				<a href='".INFUSIONS."fusion_voice_panel/voice_admin.php?aid=".iAUTH."&amp;action=1&amp;project_id=".$p['project_id']."'>".$locale['fuvo_006']."</a> /
 				<a href='".INFUSIONS."fusion_voice_panel/voice_admin.php?aid=".iAUTH."&amp;action=2&amp;project_id=".$p['project_id']."'>".$locale['fuvo_007']."</a> /
  				<a href='#' id='status-button".$p['project_id']."'>".$locale['fuvo_020']."</a>
  			</td>\n";
 			echo "</tr>\n<tr>\n";
			echo "<td class='tbl2' colspan='3' align='center' id='status".$p['project_id']."' style='display: none'>\n";
			echo "<table cellpadding='5' cellspacing='3' style='width: 75px' align='center'><tr>\n";
			for ($k=1; $k < 5; $k++) {
				echo "<td class='".($p['project_status'] == $k ? "tbl2" : "tbl1")."'><a href='javascript:void(0);' onclick='ajaxCall(\"status".$p['project_id']."\", \"aid=".iAUTH."&amp;action=2&amp;project_id=".$p['project_id']."&amp;status=".$k."\");'>".$locale['status'][$k]."</a></td>\n";
			}
			echo "</tr></table>\n";
			echo "</td>\n";
		}
		echo "</tr>\n</table>
		<a href='".FUSION_SELF."'>".$locale['fuvo_040']."</a>
			<script type='text/javascript'>
				$(function() {
					$('#vote".$p['project_id']."').click(function() {
						$('#vote-options".$p['project_id']."').toggle(300);
						return false;
					});
					$('#status-button".$p['project_id']."').click(function() {
						$('#status".$p['project_id']."').toggle(300);
						return false;
					});
							});
				function ajaxCall(div_votes, votes, div_total, total) {
					var url = 'do.php';
					$.ajax({
						async: false,
						type: 'GET',
						url: url,
						data: votes,
						success: function(result) {
							$('#' + div_votes).html(result);
						}
					});
					$.ajax({
						async: false,
						type: 'GET',
						url: url,
						data: total,
						success: function(result) {
							$('#' + div_total).html(result);
						}
					});
				}
			</script>\n";
		closetable();
		require_once INCLUDES."comments_include.php";
		showcomments("FV", DB_PREFIX."voice_projects", "project_id", $_GET['project_id'], FUSION_SELF."?project_id=".$_GET['project_id']);
	} else {
		redirect(FUSION_SELF);
		exit();
	}
} else {
	echo "<table cellpadding='5' cellspacing='1' width='100%' align='center' class='tbl-border'><tr>\n";
	if (iMEMBER) {
		echo "<td class='tbl2' width='55%' align='left' valign='middle'>\n";
		$submit_successful = false;
		$submit['name'] = "";
		$submit['description'] = "";
		if (isset($_POST['add_suggestion'])) {
			$submit['name'] = stripinput(trim(preg_replace("/ +/i", " ", $_POST['project_name'])));
			$submit['description'] = stripinput(trim(preg_replace("/ +/i", " ", $_POST['project_description'])));
			if (strlen($submit['name']) && strlen($submit['description'])) {
				$insert_project = dbquery("INSERT INTO `".DB_PREFIX."voice_projects` ( `project_name` , `project_description` , `project_user` , `project_datestamp`)
											VALUES ('".$submit['name']."', '".$submit['description']."', '".$userdata['user_id']."', '".time()."')");
				if ($insert_project) {
					echo "<p style='text-align: center; vertical-align: middle; padding: 10px 0'>".$locale['fuvo_008']."<br /><br /><a href='".FUSION_SELF."'>".$locale['fuvo_009']."</a></p>\n";
				} else {
					echo "<p style='text-align: center; vertical-align: middle; padding: 10px 0'>".$locale['fuvo_010']."<br /><br /><a href='".FUSION_SELF."'>".$locale['fuvo_011']."</a></p>\n";
				}
				$submit_successful = true;
			}
		}
		if ($submit_successful == false) {
			echo "<form name='suggest' action='' method='post'>\n";
			echo "<table cellpadding='5' cellspacing='3' width='100%' align='center'><tr>\n";
			echo "<td class='tbl2'></td><td class='tbl2' align='left'><h2>".$locale['fuvo_012']."</h2></td>\n";
			echo "</tr>\n<tr>\n";
			echo "<td class='tbl2' align='left' valign='top'>".$locale['fuvo_013']." </td>\n";
			echo "<td class='tbl2' align='center'><input type='text' name='project_name' value='".$submit['name']."' class='textbox' maxlength='100' style='width: 220px;' /></td>\n";
			echo "</tr>\n<tr>\n";
			echo "<td align='left' valign='top'>".$locale['fuvo_014']."</td>\n";
			echo "<td align='center'><textarea name='project_description' class='textbox' cols='30' rows='3' style='width: 220px;'>".$submit['description']."</textarea><br />".display_bbcodes("150px;", "project_description", "suggest", "smiley|b|i|u|url")."</td>\n";
			echo "</tr></table>\n";
			echo "<div align='center'><input type='submit' name='add_suggestion' value='".$locale['fuvo_015']."' class='button' /></div></form>\n";
		}
		echo "</td>\n";
		$select_user_votes = dbquery("SELECT tvp.project_id, tvp.project_name, tv.voice_option FROM ".DB_PREFIX."voice_projects tvp LEFT JOIN ".DB_PREFIX."voice tv ON tvp.project_id=tv.project_id WHERE tv.voice_user = '".$userdata['user_id']."' AND tv.voice_option > 0 ORDER BY tvp.project_datestamp DESC LIMIT 5");
		$votes_awarded = 0;
		echo "<td id='voted' class='tbl2' align='center' style='vertical-align: ".(dbrows($select_user_votes) ? "top" : "middle")."'>\n";
		if (dbrows($select_user_votes)) {
			echo $locale['fuvo_018'];
			echo "<table cellpadding='5' cellspacing='3' width='100%' align='center'>\n";
			echo "<tr>\n";
			echo "<td class='tbl2' align='center' width='50'><b>".$locale['fuvo_038']."</b></td>\n";
			echo "<td class='tbl2' align='center'><b>".$locale['fuvo_039']."</b></td>\n";
			echo "</tr>\n";
			while ($xdata = dbarray($select_user_votes)) {
				$votes_awarded += $xdata['voice_option'];
				echo "<tr>\n";
				echo "<td class='tbl1' align='center'>".$xdata['voice_option']."</td>\n";
				echo "<td class='tbl1'><a href='".FUSION_SELF."?project_id=".$xdata['project_id']."'>".$xdata['project_name']."</a></td>\n";
				echo "</tr>\n";
			}
			echo "</table>\n";
			echo "<script type='text/javascript'>$('#voted').css('vertical-align', 'top');</script>";
		} else {
			echo "<script type='text/javascript'>$('#voted').css('vertical-align', 'middle');</script>";
			echo $locale['fuvo_019'];
		}
		echo "<p style='padding: 10px 0'>" . $locale['fuvo_049'] . remaining_votes($votes_awarded) . "</p>\n";
		echo "</td></tr>\n";
	} else {
		echo "<td style='text-align: center; vertical-align: middle; padding: 10px 0; font-weight: bold'>".$locale['fuvo_005']."</td></tr>\n";
	}
	echo "</table><br />\n";
	echo "<div class='tbl2 tbl-border' style='padding: 10px; text-align: justify'>".nl2br(parseubb(parsesmileys($voice_settings['rules'])))."</div><br />\n";
	if (!isset($_GET['page']) || !preg_match("#^[0-4]$#", $_GET['page'])) { $_GET['page'] = 0; }
	$tab_active_style = "border-bottom: 0";	$voice_counters = array(0 => 0, 1 => 0, 2 => 0, 3 => 0, 4 => 0);
	$dbget = dbquery("SELECT project_status status, COUNT(project_status) as count FROM ".DB_PREFIX."voice_projects GROUP BY project_status");
	while ($row = dbarray($dbget)) {
		$voice_counters[$row['status']] = $row['count'];
	}
	echo "<table cellpadding='5' cellspacing='0' width='95%' align='center'><tr>\n";
	for ($i=0; $i<5; $i++) {
		echo "<td class='".($_GET['page'] == $i ? "tbl1 tbl-border" : "tbl2")."' style='vertical-align: middle; ".($_GET['page'] == $i ? $tab_active_style : "")."' align='center'><a href='".FUSION_SELF."?page=".$i."' style='display: block; height: 100%; padding: 10px 0'><b>".$locale['tabs'][$i].($i > 0 ? " (" . $voice_counters[$i] . ")" : "")."</b></a></td>\n";
	}
	echo "</tr></table>\n";
	echo "<table class='tbl-border' width='100%'><tr><td>\n";
	echo list_projects($_GET['page'], $voice_settings['projects_per_page']);
	echo "</td></tr></table>\n";
}
require_once THEMES."templates/footer.php";
?>
