<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: fusion_voice_panel.php
| Version: 1.0, December 27th, 2011
| Author: Ionescu Vlad (Senzo)
| Co-author: Nicolae Crefelean (kneekoo)
| Co-Co-author: Philip Daly (HobbyMan)
| Website: http://www.phpfusion.ro/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }

if (!defined("DB_VOICE_PROJECTS")) {
	define("DB_VOICE_PROJECTS", DB_PREFIX."voice_projects");
}
require_once INFUSIONS."fusion_voice_panel/includes/locale.php";

openside($locale['lfvp_001']);
$result = dbquery(
				"SELECT
				project_id,
				project_name,
				project_user,
				project_votes
				FROM ".DB_VOICE_PROJECTS."
				WHERE project_status !='4'
				ORDER BY
				project_datestamp
				DESC LIMIT 0,5
		");

if (dbrows($result)) {
	while ($data = dbarray($result)) {
		$get_user = dbarray(dbquery("SELECT user_id, user_name, user_status FROM ".DB_USERS." WHERE user_id = '".$data['project_user']."'"));
		$comment_count = dbcount("(comment_id)", DB_COMMENTS, "comment_type='FV' AND comment_item_id = '".$data['project_id']."'");

		echo "<p>\n";
		echo "<img src='".INFUSIONS."fusion_voice_panel/accept.gif' style='width: 16px; height: 16px; position: relative; top: 4px' alt='".$locale['lfvp_003']."' />".$data['project_votes']."\n";
		echo "<img src='".INFUSIONS."fusion_voice_panel/comment.gif' style='width: 16px; height: 16px; position: relative; top: 4px' alt='".$locale['lfvp_004']."' /> ".$comment_count."\n";
		echo profile_link($data['project_user'], $get_user['user_name'], $get_user['user_status']).":<br />\n";
		echo "<a href='".INFUSIONS."fusion_voice_panel/fusion_voice.php?project_id=".$data['project_id']."' title='".$data['project_name']."' class='side'>".trimlink($data['project_name'], 34)."</a></p><hr />\n";

	}
} else {
	echo "<div style='text-align:center'>".$locale['lfvp_002']."</div>\n";
}
closeside();
?>
