<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: infusion.php
| Version: 1.0, December 27th, 2011
| Author: Ionescu Vlad (Senzo)
| Co-author: Nicolae Crefelean (kneekoo)
| Co-Co-author: Philip Daly (HobbyMan)
| Website: http://www.phpfusion.ro/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { exit(); }

$inf_folder = "fusion_voice_panel";
require_once INFUSIONS.$inf_folder."/includes/locale.php";

$inf_title = $locale['title'];
$inf_description = $locale['description'];
$inf_version = "1.0";
$inf_developer = "Senzo";
$inf_email = "s3nzzo@yahoo.com";
$inf_weburl = "http://www.phpfusion.ro/";

$inf_newtable[1] = DB_PREFIX."voice_projects (
	`project_id` TINYINT(8) NOT NULL AUTO_INCREMENT,
	`project_name` VARCHAR(100) NOT NULL,
	`project_description` TEXT NOT NULL,
	`project_user` MEDIUMINT(8) UNSIGNED NOT NULL,
	`project_datestamp` INT(10) NOT NULL,
	`project_status` TINYINT(1) NOT NULL DEFAULT '1',
	`project_votes` INT(10) NOT NULL DEFAULT '0',
	PRIMARY KEY (`project_id`)
) ENGINE=MyISAM;";

$inf_newtable[2] = DB_PREFIX."voice (
	`voice_id` INT(8) UNSIGNED NOT NULL AUTO_INCREMENT,
	`voice_user` VARCHAR(30) NOT NULL,
	`project_id` TINYINT(8) NOT NULL,
	`voice_option` TINYINT(1) NOT NULL,
	`voice_datestamp` INT(10) NOT NULL,
	PRIMARY KEY (`voice_id`)
) ENGINE=MyISAM;";

$inf_newtable[3] = DB_PREFIX."voice_settings (
	`votes_limit` INT(8) NOT NULL,
	`projects_per_page` INT(2) NOT NULL,
	`rules` TEXT
) ENGINE=MyISAM;";

$inf_insertdbrow[1] = DB_PREFIX."voice_settings (votes_limit, projects_per_page, rules) VALUES('10', '5', '".$locale['rules']."')";

$inf_droptable[1] = DB_PREFIX."voice_projects";
$inf_droptable[2] = DB_PREFIX."voice";
$inf_droptable[3] = DB_PREFIX."voice_settings";

$inf_adminpanel[1] = array(
	"title" => $inf_title,
	"image" => "",
	"panel" => "voice_admin.php",
	"rights" => "FVP"
);

$inf_sitelink[1] = array(
	"title" => $inf_title,
	"url" => "fusion_voice.php",
	"visibility" => "0"
);

?>
