<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: English.php
| Version: 1.0, December 27th, 2011
| Author: Ionescu Vlad (Senzo)
| Co-author: Nicolae Crefelean (kneekoo)
| Co-Co-author: Philip Daly (HobbyMan)
| Website: http://www.phpfusion.ro/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
$locale['title'] = "User&#39;s Voice";
$locale['description'] = "This infusion offers the users a mean to prioritize accepted projects based on their own preferences.";
$locale['rules'] = "This section is meant to correctly prioritize the needs of the ".$settings['sitename']." users. Suggest components and vote for the most important ones, as you consider. You only have 10 points ar your disposal, so only vote for the suggestions that are the most important for you. After they get finished you will get your points back.

[b]Be aware![/b] You can take your points back at any time if you need to vote for something more important.";

$locale['fuvo_001'] = "Vote!";
$locale['fuvo_002'] = "point";
$locale['fuvo_003'] = "points";
$locale['fuvo_004'] = "Sent by";
$locale['fuvo_005'] = "Only authenticated users can send suggestions.";
$locale['fuvo_006'] = "Edit";
$locale['fuvo_007'] = "Delete";
$locale['fuvo_008'] = "Your suggestion was sent successfully!";
$locale['fuvo_009'] = "Add another suggestion.";
$locale['fuvo_010'] = "An error occured while saving the data.";
$locale['fuvo_011'] = "Try again.";
$locale['fuvo_012'] = "Got a suggestion?";
$locale['fuvo_013'] = "Title:";
$locale['fuvo_014'] = "Description:";
$locale['fuvo_015'] = "Send";
$locale['fuvo_016'] = "vote left";
$locale['fuvo_017'] = "votes left";
$locale['fuvo_018'] = "The last suggestions you voted for:<br />";
$locale['fuvo_019'] = "You have not sent any suggestion.";
$locale['fuvo_020'] = "Change status";
$locale['fuvo_021'] = "You exceeded your vote limit!<br />";
$locale['fuvo_022'] = "comment";
$locale['fuvo_023'] = "comments";
$locale['fuvo_024'] = "Read more";
$locale['fuvo_025'] = "Change status";
$locale['fuvo_026'] = "No suggestions here.";
$locale['fuvo_027'] = "Control panel";
$locale['fuvo_028'] = "Settings saved successfully.";
$locale['fuvo_029'] = "Save";
$locale['fuvo_030'] = "Changes saved successfully.";
$locale['fuvo_031'] = "Maximum number of sugestions per page:";
$locale['fuvo_032'] = "Maximum number of points per user:";
$locale['fuvo_033'] = "Suggestion";
$locale['fuvo_034'] = "Description";
$locale['fuvo_035'] = "The suggestion was deleted.";
$locale['fuvo_036'] = "Delete!";
$locale['fuvo_037'] = "Are you sure you want to delete this suggestion?";
$locale['fuvo_038'] = "Points";
$locale['fuvo_039'] = "Title";
$locale['fuvo_040'] = "Back to the suggestions list";
$locale['fuvo_041'] = "Yes";
$locale['fuvo_042'] = "No";
$locale['fuvo_043'] = "Confirm";
$locale['fuvo_044'] = "This project does not exist or it got deleted by an administrator in the meantime.";
$locale['fuvo_045'] = "Deletion cancelled.";
$locale['fuvo_046'] = "Back to the settings";
$locale['fuvo_047'] = "Rules<br /><span class='small'><i>Short rules have more chances of being read and obeyed.</i></span>";
$locale['fuvo_048'] = "The input data was not valid.";
$locale['fuvo_049'] = "Remaining points: ";

$locale['tabs'][0] = "Top Suggestions";
$locale['tabs'][1] = "New Suggestions";
$locale['tabs'][2] = "Accepted";
$locale['tabs'][3] = "Finished";
$locale['tabs'][4] = "Refused";

$locale['status'][1] = "New";
$locale['status'][2] = "Accepted";
$locale['status'][3] = "Finished";
$locale['status'][4] = "Refused";

$locale['lfvp_001'] = "Latest Voices";
$locale['lfvp_002'] = "No Suggestions Entered!";
$locale['lfvp_003'] = "votes";
$locale['lfvp_004'] = "comments";
?>
