<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2011 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: voice_admin.php
| Version: 1.0, December 27th, 2011
| Author: Ionescu Vlad (Senzo)
| Co-author: Nicolae Crefelean (kneekoo)
| Co-Co-author: Philip Daly (HobbyMan)
| Website: http://www.phpfusion.ro/
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
include "../../maincore.php";
if (!checkrights("FVP") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../../index.php"); }

require_once THEMES."templates/admin_header.php";
require_once INCLUDES."bbcode_include.php";
require_once INFUSIONS."fusion_voice_panel/includes/locale.php";

opentable($locale['title']." - ".$locale['fuvo_027']);
$_GET['action'] = isset($_GET['action']) && isnum($_GET['action']) ? $_GET['action'] : 0;
switch($_GET['action']) {
	case 0:
		$voice_settings = dbarray(dbquery("SELECT * FROM ".DB_PREFIX."voice_settings"));
		if(isset($_POST['save'])) {
			if (preg_match("#([0-9]+)#", $_POST['votes_limit']) && preg_match("#([0-9]+)#", $_POST['projects_per_page']) && $rules = stripinput($_POST['rules'])) {
				$update_voice_settings = dbquery("UPDATE ".DB_PREFIX."voice_settings SET `votes_limit` = '".$_POST['votes_limit']."', `projects_per_page` = '".$_POST['projects_per_page']."', `rules` = '".$rules."'");
				if ($update_voice_settings) {
					echo "<br /><p align='center'>" . $locale['fuvo_028'] . "</p>\n";
					echo "<p align='center'><a href='".INFUSIONS."fusion_voice_panel/fusion_voice.php'>" . $locale['fuvo_040'] . "</a> :: <a href='".FUSION_SELF.$aidlink."'>" . $locale['fuvo_046'] . "</a></p>";
				}
			} else {
					echo "<br /><p align='center'>" . $locale['fuvo_048'] . "</p>\n";
					echo "<p align='center'><a href='".INFUSIONS."fusion_voice_panel/fusion_voice.php'>" . $locale['fuvo_040'] . "</a> :: <a href='".FUSION_SELF.$aidlink."'>" . $locale['fuvo_046'] . "</a></p>";
			}
		} else {
			echo "<form name='settings' method='post' action=''>\n";
			echo "<table cellpadding='3' cellspacing='5' align='center' width='70%'><tr>\n";
			echo "<td class='tbl1'>".$locale['fuvo_031']."</td>\n";
			echo "<td class='tbl1'><input type='text' name='projects_per_page' class='textbox' value='".$voice_settings['projects_per_page']."' /></td>\n";
			echo "</tr>\n<tr>\n";
			echo "<td class='tbl1'>".$locale['fuvo_032']."</td>\n";
			echo "<td class='tbl1'><input type='text' name='votes_limit' class='textbox' value='".$voice_settings['votes_limit']."' /></td>\n";
			echo "</tr>\n<tr>\n";
			echo "<td class='tbl1' valign='top'>".$locale['fuvo_047']."</td>\n";
			echo "<td class='tbl1'><textarea name='rules' rows='7' cols='40' class='textbox'>".$voice_settings['rules']."</textarea><br />".display_bbcodes("150px;", "rules", "settings", "smiley|b|i|u|url")."</td>\n";
			echo "</tr>\n<tr>\n";
			echo "<td class='tbl1' colspan='2' align='center'><input type='submit' name='save' value='".$locale['fuvo_029']."' class='button'/></td>\n";
			echo "</tr></table></form>\n";
		}
	break;

	case 1:
	if (!isset($_GET['project_id']) && !isnum($_GET['project_id'])) { die(); }
	$select_project = dbquery("SELECT * FROM ".DB_PREFIX."voice_projects WHERE project_id = '".$_GET['project_id']."'");
	if (dbrows($select_project)) {
		$data = dbarray($select_project);
		if (isset($_POST['edit'])) {
			$update = dbquery("UPDATE ".DB_PREFIX."voice_projects SET project_name = '".stripinput($_POST['project_name'])."', project_description = '".stripinput($_POST['project_description'])."' WHERE project_id = '".$_GET['project_id']."'");
			if($update) {
				echo "<br /><p align='center'>" . $locale['fuvo_030'] . "</p>\n";
				echo "<p align='center'><a href='".INFUSIONS."fusion_voice_panel/fusion_voice.php'>" . $locale['fuvo_040'] . "</a></p>";
			}
		} else {
			echo "<form name='propose' method='post' action=''>";
			echo "<table cellpadding='3' cellspacing='5' align='center' width='70%'><tr>";
			echo "<td class='tbl1'>".$locale['fuvo_033']."</td>";
			echo "<td class='tbl1'><input type='text' name='project_name' class='textbox' value='".$data['project_name']."' /></td>";
			echo "</tr>\n<tr>";
			echo "<td class='tbl1' valign='top'>".$locale['fuvo_034']."</td>";
			echo "<td class='tbl1'><textarea cols='40' rows='7' name='project_description' class='textbox'>".$data['project_description']."</textarea><br />".display_bbcodes("150px;", "project_description", "propose", "smiley|b|i|u|url")."</td>";
			echo "</tr>\n<tr>";
			echo "<td class='tbl1' colspan='2' align='center'><input type='submit' name='edit' value='".$locale['fuvo_006']."' class='button'/></td>";
			echo "</tr></table></form>";
		}
	} else {
		redirect(BASEDIR."index.php");
	}
	break;

	case 2:
	if (!isset($_GET['project_id']) && !isnum($_GET['project_id'])) { die(); }
		if (isset($_POST['delete']) && isset($_POST['project_id']) && isnum($_POST['project_id']) && isset($_POST['choice'])) {
			if ($_POST['choice'] == "1") {
				$delete = dbquery("DELETE FROM ".DB_PREFIX."voice_projects WHERE project_id = '".$_GET['project_id']."'");
				$cleanup = dbquery("DELETE FROM ".DB_PREFIX."voice WHERE project_id = '".$_GET['project_id']."'");
				if ($delete && $cleanup) {
					echo "<br /><p align='center'>" . $locale['fuvo_035'] . "</p>\n";
					echo "<p align='center'><a href='".INFUSIONS."fusion_voice_panel/fusion_voice.php'>" . $locale['fuvo_040'] . "</a></p>";
				} else {
					echo "<br /><p align='center'>" . $locale['fuvo_044'] . "</p>\n";
					echo "<p align='center'><a href='".INFUSIONS."fusion_voice_panel/fusion_voice.php'>" . $locale['fuvo_040'] . "</a></p>";
				}
			} else {
				echo "<br /><p align='center'>" . $locale['fuvo_045'] . "</p>\n";
				echo "<p align='center'><a href='".INFUSIONS."fusion_voice_panel/fusion_voice.php'>" . $locale['fuvo_040'] . "</a></p>";
			}
		} else {
			echo "<form method='post' action=''>";
			echo "<br /><p align='center'>".$locale['fuvo_037']."</p>\n";
			echo "<p align='center' style='padding: 10px 0'><input type='hidden' name='project_id' value='".$_GET['project_id']."' />\n";
			echo "<label><input type='radio' name='choice' value='1' style='vertical-align: middle' /> ".$locale['fuvo_041']."</label>&nbsp;&nbsp;&nbsp;&nbsp;\n";
			echo "<label><input type='radio' name='choice' value='0' style='vertical-align: middle' checked='checked' /> ".$locale['fuvo_042']."</label></p>\n";
			echo "<p align='center'><input type='submit' name='delete' value='".$locale['fuvo_043']."' class='button' /></p></form>\n";
		}
	break;

}
closetable();

require_once THEMES."templates/footer.php";
?>
